#include "ext.h"
#include <IOKit/graphics/IOGraphicsLib.h> 
//#include <ApplicationServices/ApplicationServices.h> 

typedef struct _displaybrightness
{
	t_object 		m_ob;
	float 			m_brightness;
	float			m_brightnessOrg;
	io_service_t 	m_service;  
	CGDirectDisplayID m_targetDisplay;  
	CFStringRef 	m_key;
} t_displaybrightness;

void displaybrightness_float(t_displaybrightness *x, double f);
void displaybrightness_init(t_displaybrightness *x);
void displaybrightness_free(t_displaybrightness *x);
void *displaybrightness_new(double f);

void *displaybrightness_class;


void displaybrightness_float(t_displaybrightness *x, double f)
{
	CGDisplayErr dErr;  
	x->m_brightness = f;
	if (f < 0.) x->m_brightness = 0.;
	if (f > 1.) x->m_brightness = 1.;
	dErr = IODisplaySetFloatParameter(x->m_service, kNilOptions, x->m_key, x->m_brightness);  
	if (dErr != kIOReturnSuccess)	error("displaybrightness: couldn't set brightness");
	
}

void displaybrightness_init(t_displaybrightness *x)
{
	x->m_targetDisplay = CGMainDisplayID();  
	x->m_service = CGDisplayIOServicePort(x->m_targetDisplay);  
	x->m_key = CFSTR(kIODisplayBrightnessKey);  
//	x->m_brightness = HUGE_VALF;  
}

void displaybrightness_free(t_displaybrightness *x)
{
	CGDisplayErr dErr;  
	dErr = IODisplaySetFloatParameter(x->m_service, kNilOptions, x->m_key, x->m_brightnessOrg);
	if (dErr != kIOReturnSuccess)	error("couldn't set original brightness");
}

void *displaybrightness_new(double f)
{
	CGDisplayErr dErr;  
	t_displaybrightness *x = (t_displaybrightness *)newobject(displaybrightness_class);
	displaybrightness_init(x);
	dErr = IODisplayGetFloatParameter(x->m_service, kNilOptions, x->m_key, &x->m_brightnessOrg);
	if (dErr != kIOReturnSuccess) {
		error("displaybrightness: couldn't get brightness info.");
		return NULL;
	}
	if (f != 0.) displaybrightness_float(x, f);
	return x;
}

void main() 
{  
	setup((t_messlist **)&displaybrightness_class, 
			(method)displaybrightness_new, 
			(method)displaybrightness_free, 
			(short)sizeof(t_displaybrightness), 
			0L, 
			A_DEFFLOAT, 0);
	addfloat((method)displaybrightness_float);
} 
